package N
import scala.concurrent.duration._
import N._
import io.gatling.core.Predef._
import io.gatling.http.Predef._
import io.gatling.jdbc.Predef._
import scala.util.Random 
import java.util.Calendar


object G_081_Portlet{

//---------------------Set Up script specific Params Here -------------------------------------------------------------------------*/

	val THINKTIME = 5
	val attrMinThinkTimePercent = 80
	val attrMaxThinkTimePercent = 120
	val pEPortalNetworkType = "N3"
	val ScriptReferencePrefix = "081_G"
	val attrBatchSize = 2
	val attrBatchItemPacingSeconds = 180
	
/*------------------------------------------------------------------------------------------------------------*/	
	
	var minthinktime = ((THINKTIME * attrMinThinkTimePercent)/100).toLong
	var maxthinktime = ((THINKTIME * attrMaxThinkTimePercent)/100).toLong
	var E2ETransactionName = ""
	var BITTransactionName = ""
	var initTime : Long = 0
	var endTime : Long = 0
	var attBatchPacingRemain : Long = 0

	if(pEPortalNetworkType == "N3"){
		E2ETransactionName  = "E2E_081_G_E_Portal_N3_Portlet_MyXXX_ViewXXX"
		BITTransactionName  = "BIT_081_G_E_Portal_N3_Portlet_MyXXX_ViewXXX"
	}
	else{
		E2ETransactionName  = "E2E_081_G_E_Portal_W3_Portlet_MyXXX_ViewXXX"
		BITTransactionName  = "BIT_081_G_E_Portal_W3_Portlet_MyXXX_ViewXXX"
	}	
	
	def randomFunc() = Random.nextInt(100)
	
/*-----------------------Starting of Script Logic--------------------------------------------------------------*/		
		val headers_2 = Map(
		"Accept" -> "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9",
		"Sec-Fetch-Dest" -> "document",
		"Sec-Fetch-Mode" -> "navigate",
		"Sec-Fetch-Site" -> "same-origin",
		"Sec-Fetch-User" -> "?1",
		"Upgrade-Insecure-Requests" -> "1",
		"sec-ch-ua-mobile" -> "?0")
		
		val script = 
				exec{session => session.set("NetworkType",pEPortalNetworkType.toString)
								.set("aScriptReferencePrefix",ScriptReferencePrefix.toString)
								//.set("attrBatchSize",BatchSize)
								//.set("attrBatchItemPacingSeconds",BatchItemPacingSeconds)
								.set("minThinkTime",minthinktime)
								.set("maxThinkTime",maxthinktime)
					}
				/*.exec(session =>{
					val cal = Calendar.getInstance()
					println("TIMEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE" + cal.get(Calendar.YEAR ))
					println("TIMEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE" + session("gatling.http.cache.baseUrl").as[String])
				session
				})*/
				.group(E2ETransactionName){
					doIf(GlobalVariableConstants.iDoOverrideEHubLandingPage == "FALSE"){
						exec(funRenderEHub.funRenderEHubContents)
					}
					.pause("${minThinkTime}", "${maxThinkTime}")
					
					.doIf(GlobalVariableConstants.iEUserLoggedOn == "FALSE"){
						exec(session => {
							session.set("iEUserLoggedOn", GlobalVariableConstants.iEUserLoggedOn)
						})
						.exec(funEPortalLogOn.funEPortalLogOn)
										
					.exec(session => {
									session.set("aCallingAction", "DashboardLoad")
								})
					.exec(funEPortalManageDashboards.funEPortalManageDashboards)
					}
					
					.pause("${minThinkTime}", "${maxThinkTime}")
					
					.repeat(attrBatchSize){
							group(BITTransactionName){
							exec(session => {
								initTime = System.currentTimeMillis()/1000
								//session.set("InitTime" , initTime)
							session	
							})
							.group("081_G_${NetworkType}_2010_RequestRenderOfXXXDocument"){
								exec(http("OnlineXXX")
								.get("/${dynPayslipUrl}")
								.headers(headers_2)
								.check(status.is(200),headerRegex("content-disposition", """.*ePayslip.pdf.*""").find))
							}
							
							.pause("${minThinkTime}", "${maxThinkTime}")
							
							.doIf(session => {randomFunc()} <= GlobalVariableConstants.PORTAL_E_DASHBOARD_RETURN_FROM_E_PERCENTAGE){
								exec(session => {
										session.set("aCallingAction", "DashboardReturn")
									})
								.exec(funEPortalManageDashboards.funEPortalManageDashboards)
							}
						}
						.exec(session => {
								endTime = System.currentTimeMillis()/1000
								//session.set("InitTime" , initTime)
								//val iBatchItemPacingSeconds = session("attrBatchItemPacingSeconds")
								val timespent = endTime - initTime
								if(attrBatchItemPacingSeconds.toLong > timespent){
									attBatchPacingRemain = attrBatchItemPacingSeconds - timespent
									println("TIMMMMMMMMMMMMMMMMMMMMMME REMAININGGGGGGGGGGGGGGGGGGG : "+attBatchPacingRemain)
								}
								session.set("BatchPacingRemain", attBatchPacingRemain)
							})
						.pause("${BatchPacingRemain}")
					}
					.doIfEquals("${iEUserLoggedOn}", "TRUE"){
						exec(funEPortalLogOff.funEPortalLogOff)
					}
				}
}

object G_082_MyPages{
	
//---------------------Set Up script specific Params Here -------------------------------------------------------------------------*/

	val THINKTIME = 5
	val attrMinThinkTimePercent = 500
	val attrMaxThinkTimePercent = 600
	val pEPortalNetworkType = "N3"
	val ScriptReferencePrefix = "082_G"
	val attrBatchSize = 2
	val attrBatchItemPacingSeconds = 180
	
/*------------------------------------------------------------------------------------------------------------*/	
	
	var minthinktime = ((THINKTIME * attrMinThinkTimePercent)/100).toLong
	var maxthinktime = ((THINKTIME * attrMaxThinkTimePercent)/100).toLong
	var E2ETransactionName = ""
	var BITTransactionName = ""
	var initTime : Long = 0
	var endTime : Long = 0
	var attBatchPacingRemain : Long = 0
	
	var dynPayslipYear = ""
	var dynPayPeriod = ""

	if(pEPortalNetworkType == "N3"){
		E2ETransactionName  = "E2E_082_Portal_N3_MyPages_MyPayslip_ViewPayslip"
		BITTransactionName  = "BIT_082_Portal_W3_MyPages_MyPayslip_ViewPayslip"
	}
	else{
		E2ETransactionName  = "E2E_082_Portal_N3_MyPages_MyPayslip_ViewPayslip"
		BITTransactionName  = "BIT_082_Portal_W3_MyPages_MyPayslip_ViewPayslip"
	}	
	
	def randomFunc() = Random.nextInt(100)
	
/*-----------------------Starting of Script Logic--------------------------------------------------------------*/	

	val script = 
				exec{session => session.set("NetworkType",pEPortalNetworkType.toString)
								.set("aScriptReferencePrefix",ScriptReferencePrefix.toString)
								.set("minThinkTime",minthinktime)
								.set("maxThinkTime",maxthinktime)
					}
				.group(E2ETransactionName){
					
					doIf(GlobalVariableConstants.iDoOverrideEHubLandingPage == "FALSE"){
						exec(funRenderEHub.funRenderEHubContents)
					}
					.pause("${minThinkTime}", "${maxThinkTime}")
					
					.doIf(GlobalVariableConstants.iEUserLoggedOn == "FALSE"){
						exec(session => {
							session.set("iEUserLoggedOn", GlobalVariableConstants.iEUserLoggedOn)
						})
						.exec(funEPortalLogOn.funEPortalLogOn)
										
					.exec(session => {
									session.set("aCallingAction", "DashboardLoad")
								})
					.exec(funEPortalManageDashboards.funEPortalManageDashboards)
					}
					
					.pause("${minThinkTime}", "${maxThinkTime}")
					
					.exec(session =>{
						
						var cookieString = ""
						val usrsess = session("dynPopUpUser1").as[String]
						cookieString = "XXX_SESSION_STATE_" + usrsess
						//println("COOOOOOOOOOOOOKIEEEEEEEEEEEEE STRINNNNNNNNNNNNNNNNN" + cookieString)
						session.set("XXX_Cookie", cookieString)
					})
					.exec(addCookie(Cookie("${XXX_Cookie}", System.currentTimeMillis().toString)))
					
					.repeat(attrBatchSize)
						{
							group(BITTransactionName)
							{
								exec(session => {
									initTime = System.currentTimeMillis()/1000
									//session.set("InitTime" , initTime)
								session	
								})
								
								.exec(OpenFunc)
								
								.pause("${minThinkTime}", "${maxThinkTime}")
								
								.exec(session => {
									
									var dynCurrentPayslipYear = ""
									var iPayslipDetailsLength = 0
									var dynCurrentPayslipPeriod = ""
									var dynPreviousPayslipYear = ""
									var dynPreviousPayslipPeriod = ""
									var dynAssgNum : String = ""
									val cal = Calendar.getInstance()
									
									val dynPayslipDetails2List = session("dynPayslipDetails2").as[List[String]]
									val dynPayslipDetails1List = session("dynPayslipDetails1").as[List[String]]
									
									for(iArrayItem <- 0 to dynPayslipDetails2List.size-1){
										val dynPayslipDetails1 = dynPayslipDetails1List(iArrayItem).toString
										val dynPayslipDetails2 = dynPayslipDetails2List(iArrayItem).toString
										//println("LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL" + dynPayslipDetails2.length())
										iPayslipDetailsLength = dynPayslipDetails2.length()
										if (iPayslipDetailsLength == 4){
											if(dynPayslipDetails2.toInt <= cal.get(Calendar.YEAR)){
												//println("dynCurrentPayslipYear Value = " + dynCurrentPayslipYear)
												if(dynCurrentPayslipYear == "")
													dynCurrentPayslipYear = dynPayslipDetails1
												else if(dynPreviousPayslipYear == "")
													dynPreviousPayslipYear = dynPayslipDetails1
											}
										}
										if (iPayslipDetailsLength >= 40)
										{
												//println("dynCurrentPayslipPeriod Value = " + dynCurrentPayslipPeriod)
												if(dynCurrentPayslipPeriod == "")
													dynCurrentPayslipPeriod = dynPayslipDetails1
												else if(dynPreviousPayslipPeriod == "")
													dynPreviousPayslipPeriod = dynPayslipDetails1
										}
									}								
									
									
									if(session("dynAssgNum_1").as[String] == "")
										dynAssgNum = session("dynAssgNum_2").as[String]
										
									else
										dynAssgNum = session("dynAssgNum_1").as[String]									
																			
									
									session.set("dynAssgNum" , dynAssgNum)
											.set("dynCurrentPayslipYear", dynCurrentPayslipYear)
											.set("dynPreviousPayslipYear", dynPreviousPayslipYear)
											.set("dynCurrentPayslipPeriod", dynCurrentPayslipPeriod)
											.set("dynPreviousPayslipPeriod", dynPreviousPayslipPeriod)
											
									
									
								})
								
								.doIf(session => session("dynPreviousPayslipYear").as[String] != ""){
								
									exec(session =>{
										dynPayslipYear = session("dynPreviousPayslipYear").as[String]
										dynPayPeriod = session("dynPreviousPayslipPeriod").as[String]
										
										session.set("dynPayslipYear", dynPayslipYear)
												.set("dynPayPeriod", dynPayPeriod)
										
									})
									
									.group("082_G_${NetworkType}_2010_SelectAppropriatePayslipYear"){
										exec(http("request_1")
											.post("/OA_HTML/${dynActionURL_OPS_2}")
											//.headers(headers_1)
											.formParam("_AM_TX_ID_FIELD", "${dynAMTXIDFIELD}")
											.formParam("_FORM", "DefaultFormNameM7YkC4cm")
											.formParam("pPersonIDFV", "${dynPersonIDFV}")
											.formParam("pAssgNumFV", "")
											.formParam("pAssgNum", "${dynAssgNum}")
											.formParam("ForYear", "${dynPayslipYear}")
											.formParam("pPayperiod", "${dynPayPeriod}")
											.formParam("_fwkAbsolutePageName", "/custom/oracle/apps/xxh/onlinepayslip/webui/XXXXXEmpPayslipPG:::GOqMF0iR")
											.formParam("_fwkActBtnName_pAssgNum_changeAsgNum$$serverUnvalidated", "falsegHs8JABC")
											.formParam("_fwkActBtnName_ForYear_yearEvent$$serverUnvalidated", "falseH0qEG2G4")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$unvalidated", "false2v4TqY6W")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$serverUnvalidated", "falseYI5aWpvK")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$processFormDataCalled", "truetUcOb0Na")
											.formParam("paySlipBtn$$unvalidated", "falseVZW6u5Gh")
											.formParam("paySlipBtn$$serverUnvalidated", "falseej0Dg8UZ")
											.formParam("paySlipBtn$$processFormDataCalled", "trueHkQiIB9_")
											.formParam("ClearBtn$$unvalidated", "falseXuCWZDX6")
											.formParam("ClearBtn$$serverUnvalidated", "falserBULguoK")
											.formParam("ClearBtn$$processFormDataCalled", "truea4DTtqeN")
											.formParam("FORM_MAC_LIST", "${dynActionURL_MacList}")
											.formParam("_FORMEVENT", "")
											.formParam("serverValidate", "")
											.formParam("evtSrcRowIdx", "")
											.formParam("evtSrcRowId", "")
											.formParam("event", "yearEvent")
											.formParam("source", "ForYear")
											.formParam("_FORM_SUBMIT_BUTTON", "_fwkActBtnName_ForYear_yearEventYrnlrhIo")
											.formParam("partialTargets", "")
											.formParam("partial", "true")
											.check(regex("""Assignment Number""").find)
											.check(regex("""name="pPayperiod">.*?<option .*?value="(\S+?)">""").findAll.saveAs("dynPayPeriod_3"))
											.check(regex("""type="hidden" value="(\S+?)" name="FORM_MAC_LIST">""").find.optional.saveAs("dynActionURL_MacList_2"))
											)
										
										.doIf("${dynPayPeriod_3.isUndefined()}"){
											exec(session => {
												println("CLOOOOOOOOOOOOOOOOOSEEEEEEEEEEEEEEEEEEE")
											session
											})
											.exec(session =>{
												session.remove("dynActionURL_MacList")	
														.remove("dynPayslipDetails1")
														.remove("dynPayslipDetails2")
													//	.remove("HandlebarCalls")
													//	.remove("DelegateCalls")
											})
											.exec(CloseFunction)
											.exitHere								
											
										}
										
									}
									
									.exec(session =>{
										session.remove("dynActionURL_MacList")	
												.remove("dynPayslipDetails1")
												.remove("dynPayslipDetails2")
												
									})
									
									.pause("${minThinkTime}", "${maxThinkTime}")
									
									.group("082_G_${NetworkType}_2020_RequestRenderofPayslipDocument"){
										exec(session =>{
												println("PAYSSSSLIIIIPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP")
											session	
											})
										.exec(http("request_2")
											.post("/OA_HTML/${dynActionURL_OPS_2}")
											.formParam("_AM_TX_ID_FIELD", "${dynAMTXIDFIELD}")
											.formParam("_FORM", "DefaultFormNameM7YkC4cm")
											.formParam("pPersonIDFV", "${dynPersonIDFV}")
											.formParam("pAssgNumFV", "")
											.formParam("pAssgNum", "${dynAssgNum}")
											.formParam("ForYear", "${dynPayslipYear}")
											.formParam("pPayperiod", "${dynPayPeriod_3(0)}")
											.formParam("_fwkAbsolutePageName", "/custom/oracle/apps/xxh/onlinepayslip/webui/XXXXXEmpPayslipPG:::GOqMF0iR")
											.formParam("_fwkActBtnName_pAssgNum_changeAsgNum$$serverUnvalidated", "falsegHs8JABC")
											.formParam("_fwkActBtnName_ForYear_yearEvent$$serverUnvalidated", "falseH0qEG2G4")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$unvalidated", "false2v4TqY6W")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$serverUnvalidated", "falseYI5aWpvK")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$processFormDataCalled", "truetUcOb0Na")
											.formParam("paySlipBtn$$unvalidated", "falseVZW6u5Gh")
											.formParam("paySlipBtn$$serverUnvalidated", "falseej0Dg8UZ")
											.formParam("paySlipBtn$$processFormDataCalled", "trueHkQiIB9_")
											.formParam("ClearBtn$$unvalidated", "falseXuCWZDX6")
											.formParam("ClearBtn$$serverUnvalidated", "falserBULguoK")
											.formParam("ClearBtn$$processFormDataCalled", "truea4DTtqeN")
											.formParam("FORM_MAC_LIST", "${dynActionURL_MacList_2}")
											.formParam("_FORMEVENT", "")
											.formParam("serverValidate", "")
											.formParam("evtSrcRowIdx", "")
											.formParam("evtSrcRowId", "")
											.formParam("event", "paySlipBtn")
											.formParam("source", "paySlipBtn")
											.formParam("_FORM_SUBMIT_BUTTON", "")
											.formParam("partialTargets", "")
											.formParam("partial", "")
											.check(status.is(200),headerRegex("content-disposition", """.*ePayslip.pdf.*""").find)
											)
									}
									
									.exec(session =>{
											session.remove("dynActionURL_MacList_2")
									})
									
								}
								
								.doIf(session => session("dynPreviousPayslipYear").as[String] == ""){
									doIf(session => session("dynCurrentPayslipYear").as[String] != ""){
										exec(session =>{
											dynPayslipYear = session("dynCurrentPayslipYear").as[String]
											dynPayPeriod = session("dynCurrentPayslipPeriod").as[String]
											
											session.set("dynPayslipYear", dynPayslipYear)
													.set("dynPayPeriod", dynPayPeriod)
										
										})
										.group("082_G_${NetworkType}_2020_RequestRenderofPayslipDocument"){
											exec(http("request_2")
											.post("/OA_HTML/${dynActionURL_OPS_2}")
											.formParam("_AM_TX_ID_FIELD", "${dynAMTXIDFIELD}")
											.formParam("_FORM", "DefaultFormNameM7YkC4cm")
											.formParam("pPersonIDFV", "${dynPersonIDFV}")
											.formParam("pAssgNumFV", "")
											.formParam("pAssgNum", "${dynAssgNum}")
											.formParam("ForYear", "${dynPayslipYear}")
											.formParam("pPayperiod", "${dynPayPeriod_3(0)}")
											.formParam("_fwkAbsolutePageName", "/custom/oracle/apps/xxh/onlinepayslip/webui/XXXXXEmpPayslipPG:::GOqMF0iR")
											.formParam("_fwkActBtnName_pAssgNum_changeAsgNum$$serverUnvalidated", "falsegHs8JABC")
											.formParam("_fwkActBtnName_ForYear_yearEvent$$serverUnvalidated", "falseH0qEG2G4")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$unvalidated", "false2v4TqY6W")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$serverUnvalidated", "falseYI5aWpvK")
											.formParam("_fwkActBtnName_paySlipBtn_paySlipBtn$$processFormDataCalled", "truetUcOb0Na")
											.formParam("paySlipBtn$$unvalidated", "falseVZW6u5Gh")
											.formParam("paySlipBtn$$serverUnvalidated", "falseej0Dg8UZ")
											.formParam("paySlipBtn$$processFormDataCalled", "trueHkQiIB9_")
											.formParam("ClearBtn$$unvalidated", "falseXuCWZDX6")
											.formParam("ClearBtn$$serverUnvalidated", "falserBULguoK")
											.formParam("ClearBtn$$processFormDataCalled", "truea4DTtqeN")
											.formParam("FORM_MAC_LIST", "${dynActionURL_MacList_2}")
											.formParam("_FORMEVENT", "")
											.formParam("serverValidate", "")
											.formParam("evtSrcRowIdx", "")
											.formParam("evtSrcRowId", "")
											.formParam("event", "paySlipBtn")
											.formParam("source", "paySlipBtn")
											.formParam("_FORM_SUBMIT_BUTTON", "")
											.formParam("partialTargets", "")
											.formParam("partial", "")
											.check(status.is(200),headerRegex("content-disposition", """.*ePayslip.pdf.*""").find)
											)
											
										}
										
										.exec(session =>{
											session.remove("dynActionURL_MacList_2")
										})
										
									}
									
								}
								
								.pause("${minThinkTime}", "${maxThinkTime}")
								
								.exec(CloseFunction)
								
							
							}	// End of BITTransactionName
							
							.exec(session => {
								endTime = System.currentTimeMillis()/1000
								//session.set("InitTime" , initTime)
								//val iBatchItemPacingSeconds = session("attrBatchItemPacingSeconds")
								val timespent = endTime - initTime
								if(attrBatchItemPacingSeconds.toLong > timespent){
									attBatchPacingRemain = attrBatchItemPacingSeconds - timespent
									println("TIMMMMMMMMMMMMMMMMMMMMMME REMAININGGGGGGGGGGGGGGGGGGG : "+attBatchPacingRemain)
								}
								session.set("BatchPacingRemain", attBatchPacingRemain)
							})
							.pause("${BatchPacingRemain}")
						
						} // End of BatchSize loop	
						
					.doIfEquals("${iEUserLoggedOn}", "TRUE"){
						exec(funEPortalLogOff.funEPortalLogOff)
					}
				}	// End of E2ETransactionName
				
	def OpenFunc = 
					doIf(GlobalVariableConstants.iEFunctionOpen == "FALSE"){
									group("082_G_${NetworkType}_1010a_NavigateToOnlinePayslip"){
										exec(http("auditEvent_0")
											.post("/dashboard/delegate/commonServices/auditEvent")
											.formParam("eventType", "VIEW_MY_PAYSLIPS")
											.check(status.is(200)))
									}
									.pause("${minThinkTime}", "${maxThinkTime}")
									
									.group("082_G_${NetworkType}_1010_NavigateToOnlinePayslip"){
										exec(http("/OA_HTML/RF.jsp")
												.get("/OA_HTML/RF.jsp?function_id=XX_EMP_ONLINE_PAYSLIP&resp_id=${dynActionURL_RespID}&resp_appl_id=800&security_group_id=0&lang_code=US")
												.header("Accept","text/html, application/xhtml+xml, */*")
												.check(regex("""Assignment Number""").find)
												.check(regex("""<input id="FORM_MAC_LIST" type="hidden" value="(\S+?)" name="FORM_MAC_LIST">""").find.optional.saveAs("dynActionURL_MacList"))
												.check(regex("""<option value=".*?">(.*?)</option>""").findAll.optional.saveAs("dynPayslipDetails2"))
												.check(regex("""<option value="(.*?)">.*?</option>""").findAll.optional.saveAs("dynPayslipDetails1"))
												.check(regex("""name="pPayperiod"><option value="(\S+?)">\S+? - Assignment""").findAll.optional.saveAs("dynPayPeriod"))
												.check(regex("""<input id="pAssgNumFV" type="hidden" value="(.*?)"""").find.optional.saveAs("dynAssgNumFV"))
												.check(regex("""name="pAssgNum"><option value="(.*?)"""").find.optional.saveAs("dynAssgNum_2"))
												.check(regex("""name="pAssgNum"><option value="(\S+?)">\S+?</option>""").find.optional.saveAs("dynAssgNum_1"))
												.check(regex("""<input id="pPersonIDFV" type="hidden" value="(.*?)" name="pPersonIDFV">""").find.optional.saveAs("dynPersonIDFV"))
												.check(regex("""<input id="_AM_TX_ID_FIELD" type="hidden" value="(.*?)" name="_AM_TX_ID_FIELD">""").find.optional.saveAs("dynAMTXIDFIELD"))
												.check(regex("""<td><a class="x8f" href="(\S+?)"><div role="presentation"><img src="\S+?" title="Home" alt="Home"""").find.optional.saveAs("dynActionURL_OAF_99"))
												.check(regex("""action="/OA_HTML/(\S+?)"><input id="_AM_TX_ID_FIELD""").find.optional.saveAs("dynActionURL_OPS_2"))
												
											)
									}
									.exec(session => {
										session.set("iEFunctionOpen", "TRUE")	
									})
								}
								
	def CloseFunction = 
						doIfEquals("${iEFunctionOpen}","TRUE"){
							
							pause("${minThinkTime}", "${maxThinkTime}")
							
							//Click on the <Portal> hyperlink.
							.doIfOrElse(session => {randomFunc()} <= GlobalVariableConstants.PORTAL_E_DASHBOARD_RETURN_FROM_E_PERCENTAGE){
								group("082_G_${NetworkType}_8010_ReturnToEDashboard"){
									exec(http("Dashboard_Return_1")
											.get("/${dynActionURL_PortalLogOn_4}")
											.check(status.is(200), regex("""Dashboard -""").find))
								}
								.exec(session => {
									
										session.set("aCallingAction", "DashboardReturn")
												.set("iEFunctionOpen", "FALSE")
										
									})
								.exec(funEPortalManageDashboards.funEPortalManageDashboards)
							}
							{
								//Click on the <Home> link.
								group("082_G_${NetworkType}_8010_A002_ReturnToOracleApplicationsHomePage"){
									exec(http("Home")
											.get("/OA_HTML/${dynActionURL_OAF_99}")
											.check(status.is(200), regex("""Home""").find)
										)
									.exec(session => {
											session.set("iEFunctionOpen", "FALSE")
										
									})
								}
							}
							
							
							
						}
						
}